/*-----------------------------------------------------*/
/*--	Micro-EMPIX Generic ASM functions (Asm.c)     -*/
/*--    Ver 1.0 (c) 2004                              -*/
/*--	E             -*/
/*--    ==================================            -*/
/*--    .                  -*/
/*--    .                        -*/
/*--    . .                      -*/
/*-----------------------------------------------------*/

/* ====================================================*/
/* ============== Function Prototypes =================*/
/* ====================================================*/

void disabl_intr(int *ps);
void restor_intr(int *ps);
void enable_all_intr();
unsigned char port_in(int baseport, int offset);
void port_out(int baseport, int offset, unsigned char val);

/*          int *ps */

void disabl_intr(int *ps)
{
int tmp;
asm pushf ;
asm mov al,0FFh ;
asm out 21h,al ;
asm out 0A1h, al ;
asm pop tmp
*ps = tmp;
}

/*        int *ps	*/

void restor_intr(int *ps)
{
int tmp;
tmp = *ps;
asm push tmp ;
asm popf
}

/*    	*/

void enable_all_intr()
{
asm cli
asm xor al,al
asm out 21h,al
asm out 0A1h,al
asm sti
}

unsigned char port_in(int baseport, int offset)
{
        unsigned char mret = 0;

        asm MOV DX,baseport
        asm ADD DX,offset
        asm IN AL,DX
        asm MOV BYTE PTR mret,AL

        return mret;
}

void port_out(int baseport, int offset, unsigned char val)
{
        asm MOV DX,baseport
        asm ADD DX,offset
        asm MOV AL,val
        asm OUT DX,AL
}