		NAME		ctxsw
; DS value of the core
ds_store	equ		4*28h

ctxsw_text	SEGMENT		BYTE PUBLIC 'CODE'
DGROUP		GROUP		_DATA,_BSS
		ASSUME		CS:ctxsw_text, DS:DGROUP
ctxsw_text	ENDS

_DATA		SEGMENT		WORD PUBLIC 'DATA'
_DATA		ENDS

_BSS		SEGMENT 	WORD PUBLIC 'BSS'
		newip dw  ?
_BSS		ENDS

ctxsw_text	SEGMENT		BYTE PUBLIC 'CODE'

		PUBLIC		_ctxsw
_ctxsw		PROC		FAR
; We save the registers that we will use ES,BP

push bp              
push es              

; SP and BP now point to (Initial Values)-4 (Due to the two previous pushes)

mov  bp,sp           

; ==============================================================
; (1) ASSEMBLY CODE FOR SAVING ALL REGISTERS OF PREVIOUS PROCESS 
; ==============================================================

add  bp,8            ; BP points to the address of the previous process registers
mov  es,2[bp]        ; CS of previous process regiters  -> ES
mov  bp,[bp]         ; IP of previous process registers -> BP
pop  es:18[bp]       ; Save ES to previous process registers
pop  es:[bp]         ; Save BP to previous process registers

mov   es: 2[bp],ax   ; Save some additional registers
mov   es: 4[bp],bx   ;
mov   es: 6[bp],cx   ;
mov   es: 8[bp],dx   ;
mov   es: 10[bp],si  ;
mov   es: 12[bp],di  ;
mov   es: 14[bp],ds  ;
mov   es: 16[bp],ss  ;

pop   es: 22[bp]     ; Save return IP address (return to Reschedule)
pop   es: 24[bp]     ; Save return CS address (return to Reschedule)
                     
mov   es: 20[bp],sp  ; SP is saved (Points to previous processes registers address
pushf                ; Save PSW
pop   es: 26[bp]     ; 

; ===============================================================
; (2) ASSEMBLY CODE FOR UPDATING ALL REGISTERS OF CURRENT PROCESS
; ===============================================================

mov  bp,sp           ;
add  bp,4            ; 
mov  es,2[bp]        ; CS of new process registers address-> ES
mov  bp,[bp]         ; IP of new process registers address-> BP
mov  newip,bp        ; BP (IP) -> newip
                     

mov   ax, es: 2[bp]  ; Load some registers
mov   bx, es: 4[bp]  ;
mov   cx, es: 6[bp]  ;
mov   dx, es: 8[bp]  ;
mov   si, es: 10[bp] ;
mov   di, es: 12[bp] ;

mov   ss, es: 16[bp] ; We go to the stack of the new process
mov   sp, es: 20[bp] ; 


push es: 26[bp]      ; Push PSW
push es: 24[bp]      ; Push CS
push es: 22[bp]      ; Push IP
push es: 14[bp]      ; Push DS
                     
mov   bp,es:[bp]     ; Load the new BP value for the new process
push  bp             ; 
mov   bp,newip       ; 
mov   es, es:18[bp]  ; 
pop   bp	     ; 
pop   ds             ; 
iret                 ; 
		     ; 
_ctxsw		endp

ctxsw_text	ENDS

		END
